package com.maroontress.sanctuary;

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   ޥΰǤ

   macroparamǤбޤ
*/
public class MacroParameter extends Parameter {

    /** name° */
    private String name;

    /** descǤ */
    private Description desc;

    /**
       ޥΰޤ

       @param g 롼
       @param elem macroparam
    */
    public MacroParameter(final Group g, final Element elem) {
	IDManager id = IDManager.getInstance();
	name = id.getIDAttribute(elem, "name");

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(g, c.getDirectChildrenByTagName("desc"));
    }

    /**
       {@inheritDoc}
    */
    @Override public String getCode() {
	return getName();
    }

    /**
       {@inheritDoc}
    */
    @Override public String getName() {
	return name;
    }

    /**
       {@inheritDoc}
    */
    @Override public String getHTML(final Group g) {
	return "<i>" + name + "</i>";
    }

    /**
       {@inheritDoc}
    */
    @Override public String getTEX(final Group g) {
	return "\\Sarg{" + Tex.safe(name) + "}";
    }

    /**
       {@inheritDoc}
    */
    @Override public void printDetail(final PrintWriter wr) {
	wr.println(""
+ "<i>" + name + "</i> - " + desc.getText() + "<br>\n");
   }

    /**
       {@inheritDoc}
    */
    @Override public void printTexDetail(final PrintWriter wr) {
	String argName = "\\Sarg{" + Tex.safe(name) + "}";

	wr.println(""
+ "\\item[" + argName + "] " + desc.getTexText());
   }

}
